Index: trickster-lite.pl
===================================================================
RCS file: /cvsroot/trickster/trickster-lite/trickster-lite.pl,v
retrieving revision 1.32
diff -u -r1.32 trickster-lite.pl
--- trickster-lite.pl	3 Oct 2003 06:23:28 -0000	1.32
+++ trickster-lite.pl	4 Aug 2004 12:12:36 -0000
@@ -249,6 +249,50 @@
 		return;
 	    }
 
+	    # If a .htpasswd file is present, require authentication
+	    # of the user.
+
+	    my $pwfile = $Config->get('base_directory') . '/.htpasswd';
+	    my $ok = 1;
+
+	    if (-f $pwfile) {
+		$ok = 0;
+
+		if (my $auth = $request->header('Authorization')) {
+		    my($type, $pair) = split(' ', $auth);
+
+		    if ($type =~ /^basic$/i) {
+			use MIME::Base64;
+
+			my($user, $passwd) = split(':', decode_base64($pair), 2);
+
+			my $fh = FileHandle->new($pwfile) or die $!;
+
+			while (my $line = $fh->gets) {
+			    chomp($line);
+
+			    my($fuser, $fpasswd) = split(':', $line, 2);
+
+			    if ($user eq $fuser && crypt($passwd, $fpasswd) eq $fpasswd) {
+				$ok = 1;
+				last;
+			    }
+			}
+		    }
+		}
+	    }
+		
+	    if (!$ok) {
+		my $response = TricksterLite::HTTPResponse->new(401, 'Authorization Required');
+		$response->protocol("HTTP/1.0");
+		$response->push_header( 'Content-type' => 'text/plain' );
+		$response->push_header( 'WWW-Authenticate' => 'Basic realm="' . $Config->get('castname') . '"' );
+		$response->content( '401 Authorization Required' );
+		$heap->{client}->put($response);
+		warn 'auth failed!' if $Debug;
+		return;
+	    }
+
 	    # The request is real and fully formed.  Create and send back
 	    # headers in preparation for streaming the music.
 
